#include "m3x3.h"

V3& M3x3::operator[](int i) {

  return rows[i];

}

V3 M3x3::operator*(V3 v) {

  V3 ret;
  ret[0] = rows[0]*v;
  ret[1] = rows[1]*v;
  ret[2] = rows[2]*v;
  return ret;

}

M3x3 M3x3::operator*(M3x3 m1) {

  M3x3 ret;
  M3x3 &m0 = (*this);
  ret.SetColumn(0, m0*m1.GetColumn(0));
  ret.SetColumn(1, m0*m1.GetColumn(1));
  ret.SetColumn(2, m0*m1.GetColumn(2));
  return ret;

}


V3 M3x3::GetColumn(int i) {

  V3 ret(rows[0][i], rows[1][i], rows[2][i]);
  return ret;

}

void M3x3::SetColumn(int i, V3 v) {

  rows[0][i] = v[0];
  rows[1][i] = v[1];
  rows[2][i] = v[2];

}
