#include "triangle.h"
#include "linesegment.h"

Triangle::Triangle(V3 v0, V3 v1, V3 v2) {

  verts[0] = v0;
  verts[1] = v1;
  verts[2] = v2;

}

void Triangle::DrawWireframe(FrameBuffer *fb, unsigned int color) {

  for (int i = 0; i < 3; i++) {
    V3 V0 = verts[i];
    V3 V1 = verts[(i+1)%3];
    LineSegment ls(V0, V1);
    ls.Draw2D(fb, color);
  }

}

void Triangle::Rasterize(FrameBuffer *fb, unsigned int color) {

  float leftf = verts[0][0];
  float rightf = verts[0][0];
  float topf = verts[0][1];
  float bottomf = verts[0][1];

  for (int i = 1; i < 3; i++) {
    if (leftf > verts[i][0])
      leftf = verts[i][0];
    if (rightf < verts[i][0])
      rightf = verts[i][0];
    if (topf > verts[i][1])
      topf = verts[i][1];
    if (bottomf < verts[i][1])
      bottomf = verts[i][1];
  }

  for (int v = (int) topf; v <= (int) bottomf; v++) {
    for (int u = (int) leftf; u <= (int) rightf; u++) {
      fb->SetGuarded(.5f+(float)u, .5f+(float)v, color);
    }
  }

}
